/********************************************************************
 * cc_common.h     5-MAR-1993            by Y.Takeuchi (T.I.T.)     *
 * for SUN-SPARC SF-VME K2917 K3922                                 *
 *                                                                  *
 *  5-MAR-1993 Y.Takeuchi    modify for unified UNIX camlib         *
 ********************************************************************/
#ifndef CC_COMMON_DEFINITION
#define CC_COMMON_DEFINITION

/* CAMAC NAF generation macro */
#define NAF(n, a, f)    (((n) << 9) + ((a) << 5) + (f))

/* structure definition */ 
struct cc_iosb {
    int status;
    int ret_length;
    int s_reg;
    int devinfo;
};

/* CAMAC status (for cc_iosb.status) */
#define CC_STA_OK               0
#define CC_STA_SINGLE_TIMEOUT   -1
#define CC_STA_BLOCK_INVFUNC    -2
#define CC_STA_BLOCK_TIMEOUT    -3
#define CC_STA_LIST_STOP        -10
#define CC_STA_LIST_TIMEOUT     -11
#define CC_STA_LIST_EMPTY       -12
#define CC_STA_LIST_ZERODIV     -13
#define CC_STA_LIST_OVERSTEP    -14
#define CC_STA_KLIST_SAMENAME   -21
#define CC_STA_KLIST_MEMORYFULL -22
#define CC_STA_KLIST_NONAME     -23

#endif /* CC_COMMON_DEFINITION */

/*
 Description of status (by Y.Yasu, KEK)
   There are two types of status, system status and camac status.
   The system status means return camlib function value while the camac status
   means the return value of status of iosb. For examples, CC_STA_OK,
   CC_STA_SINGLE_TIMEOUT,... are the camac status.  And, ENXIO, EBUSY,.. are
   the system status which is defined in the files of the directory
   /usr/include.
   Therefore,
   system status = 0 and camac status = 0 : all are ok.
   system status = -1 and camac status !=0 : system call is ok, but camac fails
       : or list operation fails.
   system status !=0 except -1            : system call is bad.
 * status :
   camac status  : success = 0 while error != 0. The error is negative value
   which is defined in this file.
 * ret_length :
   actual length of data transferred in short word
 * s_register :
   Only a parameter which is passed to device driver.
   latest contents of s register is return
 * devinfo
    first short word  : Control Status Register(0:15)
    second short word : Channel Status/Error Register(0:4)
*/
